var BaseView = function (options) {
    Backbone.View.apply(this, [options]);
};

_.extend(BaseView.prototype, Backbone.View.prototype, {

    toggleVisibillity: function () {
        if (this.model.get("hidden")) {
            this.$el.hide();
        } else {
            this.$el.show();
        }
    },
    setBackfaceVisibility: function (backfaceVisibility) {
        CSSHandler.setBackfaceVisibility(this.$el, backfaceVisibility);
    },
    scrollWithAnimationTo: function (x, y, transitionTime, scrollEndHandler) {
        CSSHandler.scrollTo(this.$el, x, y, transitionTime, scrollEndHandler);
    },
    stopAnimation: function () {
        CSSHandler.stopAnimation(this.$el);
    },
    setWidth: function (value) {
        CSSHandler.setWidth(this.$el, value);
    },
    setHeight: function (value) {
        CSSHandler.setHeight(this.$el, value);
    },
    setMinWidth: function (value) {
        CSSHandler.setMinWidth(this.$el, value);
    },
    setBackgroundColor: function (color, opacity) {
        CSSHandler.setBackgroundColor(this.$el, color, opacity);
    },
    setTitle: function (title) {
       CSSHandler.setTitle(this.$el, title);
    },
    setBackgroundImage: function (url) {
        CSSHandler.setBackgroundImage(this.$el, url);
    },
    setBackgroundPosition: function (position) {
        CSSHandler.setBackgroundPosition(this.$el, position);
    },
    setBackgroundRepeat: function (repeat) {
        CSSHandler.setBackgroundRepeat(this.$el, repeat);
    },
    setLeft: function (value) {
        CSSHandler.setLeft(this.$el, value);
    },
    setRight: function (value) {
        CSSHandler.setRight(this.$el, value);
    },
    setTop: function (value) {
        CSSHandler.setTop(this.$el, value);
    },
    setBottom: function (value) {
        CSSHandler.setBottom(this.$el, value);
    },
    setHorizontalMargin: function (leftMargin, rightMargin) {
        CSSHandler.setHorizontalMargin(this.$el, leftMargin, rightMargin);
    },
    setVerticalMargin: function (topMargin, bottomMargin) {
        CSSHandler.setVerticalMargin(this.$el, topMargin, bottomMargin);
    },
    setHorizontalPadding: function (leftPadding, rightPadding) {
        CSSHandler.setHorizontalPadding(this.$el, leftPadding, rightPadding);
    },
    setVerticalPadding: function (topPadding, bottomPadding) {
        CSSHandler.setVerticalPadding(this.$el, topPadding, bottomPadding);
    },
    setBackgroundSize: function (width, height) {
        CSSHandler.setBackgroundSize(this.$el, width, height);
    },
    translate3D: function (xOffset, yOffset, zOffset, transitionPeriod, timingFunction, existingTransitionPeriod, use3d) {
        CSSHandler.translate3D(this.$el, xOffset, yOffset, zOffset, transitionPeriod, timingFunction, existingTransitionPeriod, use3d);
    },
    scale: function (scaleFactor) {
        CSSHandler.scale(this.$el, scaleFactor);
    },
    setPositionType: function (position) {
        CSSHandler.setPositionType(this.$el, position);
    },

    setTransitionEndHandler: function (handler) {
        CSSHandler.setTransitionEndHandler(this.$el, handler);
    },
    removeTransitionEndHandler: function () {
        CSSHandler.removeTransitionEndHandler(this.$el);
    },
    toNumber: function (value) {
        value = (null == value) ? '' : value;
        return ('' == value) ? 0 : parseFloat(value);
    },
    setZIndex: function (value) {
        CSSHandler.setZIndex(this.$el, value);
    },
    setVisibility: function (visibility) {
        CSSHandler.setVisibility(this.$el, visibility);
    },
    setOpacity: function (opacity) {
        CSSHandler.setOpacity(this.$el, opacity);
    },

    tapEvent: function (e) {
        try {
            var touch = this.getPosition(e);
            return !((Math.abs(touch.x - this.position.x) > 5) || (Math.abs(touch.y - this.position.y) > 5));
        } catch (e) {
            return false;
        }
    },
    getPosition: function (e) {
        return AppUtils.getMouseEventCoordinates(e);
    }


});

BaseView.extend = Backbone.View.extend;