if (!window["Book"]) window["Book"] = {};
(function (Book) {
    Book.defineClasses = function () {
        Book.ChapterModel = Backbone.Model.extend({

        });
        Book.ChapterModelCollection = Backbone.Collection.extend({
            model: Book.ChapterModel
        });
        Book.ChapterViewCollection = Backbone.View.extend({
            id: "bookViewPort",
            tagName: "div",
            initialize: function () {
                var models, idx, modelsLength, chapter;
                this.chapters = [];
                models = this.collection.models;
                modelsLength = models.length;
                this.listenTo(this.model, "change:remove", this.removeView);
                for (idx = 0; idx < modelsLength; idx++) {
                    chapter = new TocChapter(models[idx], Book.rawChapterModels[idx]);
                    chapter.init();
                    this.chapters.push(chapter);
                }
                this.listenTo(this.model, "change:childch", this.xxx);
            },
            xxx: function () {
                for (var i = 2; i < this.chapters.length; i++) {
                    this.chapters[i].getView().dodown();
                }
            },
            removeView: function () {
                var models, idx, modelsLength, chapter;
                models = this.collection.models;
                modelsLength = models.length;
                for (idx = 0; idx < modelsLength; idx++) {
                    models[idx].set("remove", true);
                }
                this.unbind();
                this.remove();
            },
            render: function () {
                var that = this;
                $(this.el).empty();
                _(this.chapters).each(function (chapter) {
                    that.$el.append(chapter.getView().render().el);
                });
                return this;
            }
        });
    };
    Book.getChapterModel = function (rawModel) {
        var model = {};
        model.id = rawModel.id;
        model.class = rawModel.class;
        model.existThumbnails = (rawModel.thumbnailsContainer.length > 0 );
        model.existAnimations = (rawModel.animationsContainer.length > 0 );
        model.existVideos = (rawModel.videosContainer.length > 0 );
        model.unExpandedHeight = 126;
        model.expandedHeight = 252;
        return model;
    };
    Book.processRawBookModel = function () {
        var idx, rawChapterModels;
        Book.rawChapterModels = [];
        Book.chapterModelCollection = new Book.ChapterModelCollection();
        rawChapterModels = Book.rawChapterModels;
        for (idx = 0; idx < rawBookModel.length; idx++) {
            rawChapterModels.push(rawBookModel[idx]);
            Book.chapterModelCollection.add(Book.getChapterModel(rawChapterModels[idx]));
        }
    };
    Book.createAndDisplayChapters = function () {
        Book.chapterModel = new Book.ChapterModel({
            remove: false
        });
        Book.chapterViewCollection = new Book.ChapterViewCollection({
            collection: Book.chapterModelCollection,
            model: Book.chapterModel
        });
        $("body").append(Book.chapterViewCollection.render().el);
    };
    Book.setupBook = function () {
        Book.defineClasses();
        Book.processRawBookModel();
        Book.createAndDisplayChapters();
    }
})(window["Book"]);