var minFileSuffix = ProjectGlobals.USE_MINIFIED_JS_FILES ? "-min" : "";

requirejs.config({
    paths: {
        jQuery: 'vendor/jquery-1.10.2.min',
        Underscore: 'vendor/underscore-min',
        Backbone: 'vendor/backbone-min',
        moment: 'vendor/moments.min',
        HashCode: 'vendor/MD5',
        Templates: 'templates/Templates' + minFileSuffix,
        printElement: "vendor/jquery.printElement.min",

        fakeCordova: "vendor/cordova/cordova",
        CordovaiOS: "vendor/cordova/cordova_iOS",
        Cordova2XiOS: "vendor/cordova2x/cordova.ios.2.7.0",
        CordovaAndroid: "vendor/cordova/cordova_android",
        Cordova2XAndroid: "vendor/cordova2x/cordova.android.2.7.0",
        CordovaWrapper: "vendor/cordova/plugins/cordovaWrapper",
        iScroll: "vendor/iscroll-lite",
        iScrollZoomLib: "vendor/iscroll-zoom",
        hammerJS: "vendor/hammer/hammer.min",
        hammerFakeMultiTouch: "vendor/hammer/plugins/hammer.fakemultitouch",
        hammerShowTouches: "vendor/hammer/plugins/hammer.showtouches",

        App: "App" + minFileSuffix,
        AppEventsEngine: "utils/AppEventsEngine" + minFileSuffix,
        AppUtils: "AppUtils" + minFileSuffix,
        MessagingAPI: "MessagingAPI" + minFileSuffix,
        CSSHandlers: "CSSHandlers" + minFileSuffix,
        ProjectSettings: "ProjectSettings" + minFileSuffix,
        HTTPRequestUtils: "HTTPRequestUtils" + minFileSuffix,
        ChapterElement: "ChapterElement" + minFileSuffix,
        BaseView: "BaseView" + minFileSuffix,

        ViewportPadding: "sideMenu/ViewportPadding" + minFileSuffix,

        SoundPlayer: "utils/SoundPlayer" + minFileSuffix,
        VideoPlayer: "utils/VideoPlayer" + minFileSuffix,
        ResourceManager: "utils/ResourceManager" + minFileSuffix,
        ModelAccessFunctions: "utils/ModelAccessFunctions" + minFileSuffix,
        OCUtils: "utils/OCUtils" + minFileSuffix,
        PageUtils: "utils/PageUtils" + minFileSuffix,
        PersistentSceneObjectsUtils: "utils/PersistentSceneObjectsUtils" + minFileSuffix,
        TransitionPlayer: 'utils/TransitionPlayer' + minFileSuffix,

        ChapterBottomMenu: 'bottomMenu/ChapterBottomMenu' + minFileSuffix,
        ActiveTabs: 'bottomMenu/ActiveTabs' + minFileSuffix,
        TocTabContentElement: 'bottomMenu/TocTabContentElement' + minFileSuffix,
        SettingsTabContentElement: 'bottomMenu/SettingsTabContentElement' + minFileSuffix,
        RecordingTabContent: 'bottomMenu/RecordingTabContent' + minFileSuffix,
        CSSConstants: 'bottomMenu/CSSConstants' + minFileSuffix,
        BottomMenuOcHandler: 'bottomMenu/BottomMenuOcHandler' + minFileSuffix,

        EffectsHandler: 'effects/Effects' + minFileSuffix,
        LinksHandler: 'effects/Links' + minFileSuffix,
        CommonActions: 'effects/CommonActions' + minFileSuffix,
        AudioTextSync: 'effects/audioTextSync' + minFileSuffix,

        ElementsBaseView: 'pages/ElementsBaseView' + minFileSuffix,
        DualPageElement: 'pages/DualPageElement' + minFileSuffix,
        PageElement: 'pages/PageElement' + minFileSuffix,
        EmptyBoxElement: 'pages/EmptyBoxElement' + minFileSuffix,
        DownloadLinkElement: 'pages/DownloadLinkElement' + minFileSuffix,
        ExternalURLElement: 'pages/ExternalURLElement' + minFileSuffix,
        ImageElement: 'pages/ImageElement' + minFileSuffix,
        TextBoxElement: 'pages/TextBoxElement' + minFileSuffix,
        SoundElement: 'pages/SoundElement' + minFileSuffix,
        SoundOverlayElement: 'pages/SoundOverlayElement' + minFileSuffix,
        VideoElement: 'pages/VideoElement' + minFileSuffix,
        AnimationElement: 'pages/animationElement/AnimationElement' + minFileSuffix,
        SceneObjectAnimation: 'pages/animationElement/SceneObjectAnimation' + minFileSuffix,
        TimedEventElement: 'pages/TimedEventElement' + minFileSuffix,
        EventElement: 'pages/EventElement' + minFileSuffix,
        DrawingElement: 'pages/drawingElement/DrawingElement' + minFileSuffix,
        DrawingElementMenu: 'pages/drawingElement/DrawingElementMenu' + minFileSuffix,
        TextInputElement: 'pages/TextInputElement' + minFileSuffix,
        CameraElement: 'pages/CameraElement' + minFileSuffix,
        PdfPackageElement: 'pages/PdfPackageElement' + minFileSuffix,
        EmbeddedSceneElement: 'pages/EmbeddedSceneElement' + minFileSuffix,
        AnchorElement: 'pages/AnchorElement' + minFileSuffix,
        QuizQuestionElement: 'pages/quizzes/QuizQuestionElement' + minFileSuffix,
        SceneObjectQuizQuestion: 'pages/quizzes/SceneObjectQuizQuestion' + minFileSuffix,
        PackageElement: 'pages/PackageElement' + minFileSuffix,

        QuizTestElement: 'pages/quizzes/QuizTestElement' + minFileSuffix,


        SoundRecorder: "platforms/browsers/recording" + minFileSuffix,
        FileDownloader: "vendor/cordova/plugins/fileDownloader",
        InAppPurchaseManager: "vendor/cordova/plugins/InAppPurchaseManager",
        PhoneGapUtils: "vendor/cordova/plugins/PhoneGapUtils",
        PluginUtils: "vendor/cordova/plugins/PluginUtils",
        PhoneGapDownload: "vendor/cordova/plugins/PhoneGapDownload",

        GenericLightBox: "lightBoxes/GenericLightBox" + minFileSuffix,
        RecordingLightBox: "lightBoxes/RecordingLightBox" + minFileSuffix,
        RecordingWizardLightBox: "lightBoxes/RecordingWizardLightBox" + minFileSuffix,
        UnlockContentLightBox: "lightBoxes/UnlockContentLightBox" + minFileSuffix,

        ZoomControls: "sideMenu/ZoomControls" + minFileSuffix,
        IScrollZoom: "zoom/IScrollZoom" + minFileSuffix,
        ZoomUtils: "zoom/ZoomUtils" + minFileSuffix,

        DownloadService: 'services/DownloadService' + minFileSuffix,
        IAPService: 'services/IAPService' + minFileSuffix,
        UpdateService: 'services/UpdateService' + minFileSuffix,
        NavigationService: 'services/NavigationService' + minFileSuffix,


        DownloadUI: 'usersNotifications/DownloadUI',
        JqueryKnob: 'usersNotifications/Jquery.knob',

        SpinnerPlugin: 'usersNotifications/Spinner-plugin'
    },
    shim: {
        Backbone: {
            deps: ['jQuery', 'Underscore'],
            exports: 'Backbone'
        },
        Underscore: {
            exports: '_'
        },
        jQuery: {
            exports: '$'
        },
        hammerJS: {
            exports: 'Hammer'
        }
    },
    waitSeconds: 0
});

function setIncludePathsForProject(computedPaths) {
    requirejs.config({
        paths: computedPaths
    });
}

function adjustDeviceDPI() {
    if (typeof NewPlayerJSBridge != "undefined" && typeof NewPlayerJSBridge.getDeviceDPI == "function") {
        var deviceDPI = NewPlayerJSBridge.getDeviceDPI();
        if (deviceDPI != "NO_CHANGE") {
            $('meta[name=viewport]').attr("content", "width=device-width, height=device-height, initial-scale=1.0, user-scalable=0, minimum-scale=1.0, maximum-scale=1.0, target-densitydpi=" + deviceDPI);
        }
    }
}

require(['jQuery'], function () {
    $(function () {
        if (ProjectGlobals.IS_TIP_OF_THE_DAY) {
            $('body').css("background-color", "");
        }
        adjustDeviceDPI();

        window.ondragstart = function () {
            return false;
        };


        require(['AppEventsEngine', 'AppUtils', 'MessagingAPI', 'ZoomUtils', 'EffectsHandler', 'LinksHandler', 'CommonActions', 'CSSHandlers', 'ModelAccessFunctions', 'ResourceManager', 'SoundOverlayElement'], function () {
            AppUtils.parentElement = AppUtils.getParentElement();
            require(['Underscore', 'Backbone', 'HTTPRequestUtils', 'ProjectSettings', 'OCUtils', 'PageUtils'], function () {
                require(['SpinnerPlugin'], function () {
                });
                //TODO: test if it is a book or a chapter

                if (true) {
                    require(['ChapterElement'], function (ChapterElement) {
                        var hashValue;
                        ProjectGlobals.START_PAGE = 0;
                        hashValue = window.location.hash;
                        if (hashValue != "") {
                            ProjectGlobals.START_PAGE = parseInt(hashValue.substring("#goToPage-".length));
                        }
                        setupAppBasicFunctions(ChapterElement);
                        Chapter.getRawModelForPages(ProjectGlobals.START_PAGE);
                    });
                }

            });

        });

    });
});

function setupAppBasicFunctions(ChapterElement) {
    var getMenuModelSuccessCallback, getMenuModelErrorCallback, getPagesModelSuccessCallback, getPagesModelErrorCallback, adjustResolutionWidthAndHeight;

    if (!window["App"]) window["App"] = {};

    if (typeof console.time == "undefined") {
        console.time = console.log; // use console.log instead
        console.timeEnd = console.log; // use console.log instead
    }

    window.Chapter = new ChapterElement();


    getMenuModelSuccessCallback = function (menuRawModel, activePage, shouldSave) {

        Chapter.setMenuModel(menuRawModel);
        if (shouldSave) {
            App.saveCurrentMenuModel(menuRawModel);
        }

        ViewportPadding.addPaddingAreas();
        AppUtils.runCustomMenuMethod("shouldSnapMenuToBottomOfScreen");

        App.viewPortView.$el.append(Chapter.getScrollingElementsWrapper().getView().render().el);

//        if(App.DeviceType.iOS){
//            var soundOverlay = new SoundOverlayElement();
//            soundOverlay.init();
//            App.viewPortView.$el.append(soundOverlay.getView().render().el);
//            soundOverlay.getView().$el.css("display", "none");
//        }

        if (ProjectGlobals.IS_TIP_OF_THE_DAY) {
            App.viewPortView.$el.css('pointer-events', 'none');
        }
        $("body").css("font-size", Math.round(16 * App.settings.scaleFactor) + "px")
            .append(App.viewPortView.render().el);

        App.viewPortModel.set("bindEvents", true); // in order to have touchstart working on iOS 5, only bind after elements were added to DOM

        if(Chapter.getSettings().readRightToLeft == true)
            activePage = Chapter.getSettings().lastPageNumber - 1;

        Chapter.setActivePage(activePage);

        require(['printElement'], function () {

        });

        if (!ProjectGlobals.IS_SCENE_PREVIEW && !ProjectGlobals.IS_TIP_OF_THE_DAY) {
            Chapter.createBottomMenu(menuRawModel, activePage, function () {
                if (ViewportPadding.shouldSnapMenuToBottomOfScreen()) {
                    $("body").append(Chapter.getBottomMenu().getView().render().el);
                } else {
                    App.viewPortView.$el.append(Chapter.getBottomMenu().getView().render().el);
                }

            });
        }
    };

    getMenuModelErrorCallback = function (error) {
        // TODO: alert user that menu wasn't loaded
        console.log("Error fetching menu model");
    };

    adjustResolutionWidthAndHeight = function (chapterSettings) {
        var offset = window.innerWidth / window.innerHeight - chapterSettings.resolutionWidth / chapterSettings.resolutionHeight;
        if (Math.abs(offset) < 0.01) {
            chapterSettings.resolutionWidth = chapterSettings.resolutionHeight * window.innerWidth / window.innerHeight;
        }
    };

    getPagesModelSuccessCallback = function (chapterRawModel, activePage, currentOrientation, shouldSave) {
        var appSettings = {},
            initialScriptNames = ['BaseView', 'ViewportPadding', 'App', 'Captions'];
        AppUtils.loadCssFiles(cssURLs(chapterRawModel.settings));

        adjustResolutionWidthAndHeight(chapterRawModel.settings);

        appSettings.originalWidth = chapterRawModel.settings.resolutionWidth;
        appSettings.originalHeight = chapterRawModel.settings.resolutionHeight;
        appSettings.backgroundCSS = chapterRawModel.settings.backgroundCSS;
        appSettings.savedOrientation = currentOrientation;

        setIncludePathsForProject(getIncludePathsProject(chapterRawModel.settings));

        if (chapterRawModel.settings.customPlayerFilesPath != null) {
            initialScriptNames.push(chapterRawModel.settings.customPlayerFilesPath + "js/CustomMenuScripts.js");
        }

        require(initialScriptNames, function () {
            AppUtils.runCustomMenuMethod("includeCustomFilesToProject");
            Chapter.initSettings(chapterRawModel.settings);
            App.init(appSettings);
            App.setAutoMediaIconsURL();
            ViewportPadding.init();
            if (shouldSave) {
                App.saveCurrentModel(chapterRawModel); // MOB-1444
            }
            Chapter.init(chapterRawModel);
            // set from here active page to -1 because we need model to be notified when page 0 is activated
            Chapter.createPages(chapterRawModel, -1, function () {
                if (!ProjectGlobals.IS_SCENE_PREVIEW) {
                    Chapter.getRawModelForMenu(activePage, currentOrientation);
                } else {
                    $("body").css("font-size", Math.round(16 * App.settings.scaleFactor) + "px")
                        .append(App.viewPortView.render().el);
                    App.viewPortView.$el.append(Chapter.getScrollingElementsWrapper().getView().render().el);
                    Chapter.setActivePage(activePage);
                }
            });
        });

    };
    getPagesModelErrorCallback = function (error) {
        // TODO: alert user that chapter couldn't be loaded
        console.log("Error fetching pages model");
    };

    Chapter.getRawModelForPages = function (activePage) {

        var currentOrientation = window.innerWidth > window.innerHeight ? SupportedOrientation.LANDSCAPE : SupportedOrientation.PORTRAIT;
        if (ProjectGlobals.ORIENTATION != SupportedOrientation.ALL) {
            if (ProjectGlobals.ORIENTATION != currentOrientation) {
                console.log("Load related now " + ProjectGlobals.RELATED_SHARE_URL);
                ProjectSettings.shareUrl = ProjectGlobals.RELATED_SHARE_URL;
            }
        }

        HTTPRequestUtils.getInstance().getJSON(ProjectSettings.URLs.chapterPagesJSONUrl(), function (chapterRawModel) {
            getPagesModelSuccessCallback(chapterRawModel, activePage, currentOrientation, true);
        }, getPagesModelErrorCallback);
    };

    Chapter.loadRelatedProjectForOrientation = function (currentOrientation, activePage) {
        if (ProjectGlobals.ORIENTATION != SupportedOrientation.ALL) {
            if (ProjectGlobals.ORIENTATION != currentOrientation) {
                console.log("Load related now " + ProjectGlobals.RELATED_SHARE_URL, "And go to page " + activePage);
                ProjectSettings.shareUrl = ProjectGlobals.RELATED_SHARE_URL;
            } else {
                console.log("Load original now " + ProjectGlobals.SHARE_URL);
                ProjectSettings.shareUrl = ProjectGlobals.SHARE_URL;
            }
            if (App.model[currentOrientation] != null) {
                getPagesModelSuccessCallback(JSON.parse(App.model[currentOrientation]), activePage, currentOrientation, false);
            } else {
                HTTPRequestUtils.getInstance().getJSON(ProjectSettings.URLs.chapterPagesJSONUrl(), function (chapterRawModel) {
                    getPagesModelSuccessCallback(chapterRawModel, activePage, currentOrientation, true);
                }, getPagesModelErrorCallback);
            }
        }
    };

    Chapter.getRawModelForMenu = function (activePage, currentOrientation) {
        if (App.menuModel[currentOrientation] != null) {
            getMenuModelSuccessCallback(JSON.parse(App.menuModel[currentOrientation]), activePage, false);
        } else {
            HTTPRequestUtils.getInstance().getJSON(ProjectSettings.URLs.chapterMenuJSONUrl(), function (menuRawModel) {
                getMenuModelSuccessCallback(menuRawModel, activePage, true);
            }, getMenuModelErrorCallback);
        }
    };

}



