var ListenerHandler = {
    browserSpecificListeners: {
        firefox: {
            fullScreenStateChange: 'mozfullscreenchange'
        },
        webkit: {
            fullScreenStateChange: 'webkitfullscreenchange'
        },
        opera: {
            fullScreenStateChange: 'fullscreenchange'
        },
        IE: {
            fullScreenStateChange: 'msfullscreenchange'
        }
    },
    currentBrowser: null,
    browserListener: null,
    cssPrefix: "",
    getCurrentBrowser: function () {
        if (navigator.userAgent.indexOf('WebKit/') > -1) {
            this.currentBrowser = 'webkit';
            this.browserListener = this.browserSpecificListeners.webkit;
        } else if (navigator.userAgent.indexOf('Firefox/') > -1) {
            this.currentBrowser = "firefox";
            this.browserListener = this.browserSpecificListeners.firefox;
        } else if (navigator.userAgent.indexOf('Opera/') > -1) {
            this.currentBrowser = "opera";
            this.browserListener = this.browserSpecificListeners.opera;
        } else if (this.isInternetExplorer()) {
            this.currentBrowser = 'ie';
            this.browserListener = this.browserSpecificListeners.IE;
        } else {
            this.currentBrowser = "webkit";
            this.browserListener = this.browserSpecificListeners.webkit;
        }
    },
    addFUllScreenStateChangeListener: function (element, fullScreenHandler, notFullScreenHandler) {
        document.addEventListener(this.browserListener.fullScreenStateChange, function () {
            if (ListenerHandler.isElementFullScreen()) {
                if (null != fullScreenHandler)
                    fullScreenHandler(true);
            } else {
                if (null != notFullScreenHandler)
                    notFullScreenHandler(false);
            }
        })

    },
    requestBrowserFullScreen: function (element) {
        if (this.currentBrowser == 'webkit')
            element.webkitRequestFullScreen();
        else if (this.currentBrowser == 'firefox')
            element.mozRequestFullScreen();
        else if (this.currentBrowser == 'opera')
            element.requestFullscreen();
        else if (this.currentBrowser == 'ie')
            element.msRequestFullscreen();
    },
    cancelBrowserFullScreen: function (element) {
        if (this.currentBrowser == 'webkit')
            document.webkitCancelFullScreen();
        else if (this.currentBrowser == 'firefox')
            document.mozCancelFullScreen();
        else if (this.currentBrowser == 'opera')
            document.exitFullscreen();
        else if (this.currentBrowser == 'ie')
            document.msExitFullscreen();
    },
    isElementFullScreen: function () {
        var ret = false;
        if (this.currentBrowser == 'webkit')
            ret = document.webkitIsFullScreen;
        else if (this.currentBrowser == 'firefox')
            ret = document.mozFullScreen;
        else if (this.currentBrowser == 'opera')
            ret = document.fullscreen;
        else if (this.currentBrowser == 'ie')
            ret = document.msFullscreenElement;
        return ret;
    }
}
ListenerHandler.getCurrentBrowser();