var ProjectGlobals = {
        SHARE_URL: null,
        SERVER_ROOT: null,
        ORIENTATION: null,
        RELATED_SHARE_URL: null,
        RELATED_ORIENTATION: null,
        DOWNLOAD_PATH: null,
        START_PAGE: null
    },

    SupportedOrientation = {
        ALL: "all",
        PORTRAIT: "portrait",
        LANDSCAPE: "landscape"
    },

    cssURLs = function (settings) {
        var ret = ['css/ProjectStyles.css', 'css/FontFaces.css', 'css/MenuSettingsStyles.css', 'css/MenuStyles.css',
            'css/LightBoxes.css', 'css/DrawingElementStyles.css', 'css/CameraElementStyles.css', 'css/AnimationStyles.css',
            'css/projectNotes.css', 'css/SideMenuStyles.css', 'css/UsersNotification.css', 'css/SoundPlayerUI.css'];

        if (null != settings['customQuizStyle']) {
            ret.push('customQuizzes/' + settings['customQuizStyle'] + '/QuizStyles.css');
        } else {
            ret.push('css/QuizStyles.css');
        }
        return ret;
    },

    androidCssURLs = ['css/platforms/android/ProjectStyles.css'],

    browsersCssURLs = ['css/platforms/browsers/ProjectStyles.css'],

    language = '',

    objectCategories = {
        '1205': {
            active: true,
            persistent: false
        }
    },

    ReadSoundSettings = {
        OWN_SOUNDS: "OWN_SOUNDS",
        SOUNDS_OFF: "SOUNDS_OFF",
        SOUNDS_ON: "SOUNDS_ON"
    },

    MenuState = {
        FULL_EXPANDED: "FULL_EXPANDED",
        DOWN_FOR_RECORDING: "DOWN_FOR_RECORDING",
        CLOSED: "CLOSED",
        ONLY_TOC: "ONLY_TOC"
    },

    VideoState = {
        WAITING: "WAITING",
        PLAY: "PLAY",
        PAUSE: "PAUSE",
        STOP: "STOP"
    },

    VideoType = {
        REGULAR: "regular",
        YOUTUBE: "youtube",
        EXTERNAL: "external"
    },

    GoToObjectType = {
        GoToScene: "Go to scene",
        GoToProject: "Go to project",
        GoToWebURL: "Go to web URL",
        GoToAppStoreURL: "Go to AppStore URL"
    },
    device = null,// TODO: what is this random var used here
    zIndex = {
        activePage: 1000000,
        inactivePage: 99999
    },
    MultimediaPlacement = {
        PLACEMENT_ABOVE: "ABOVE",
        PLACEMENT_BELLOW: "BELLOW",
        PLACEMENT_LEFT: "LEFT",
        PLACEMENT_RIGHT: "RIGHT"
    },
    DisplayType = {
        INLINE: "inline",
        ICON: "icon"
    },
    TransitionPlayerType = {
        MOVE: "MOVE",
        ZOOM: "ZOOM"
    },
    SOUND_UI_SETTINGS = {
        NO_PLAYER: "BUILD_SETTINGS_SOUND_UI_DEFAULT",
        COMPACT_PLAYER: "BUILD_SETTINGS_SOUND_UI_COMPACT_PLAYER",
        FULL_PLAYER: "BUILD_SETTINGS_SOUND_UI_FULL_PLAYER"
    },
    LOG_TAGS = {
        MOB_2206: "MOB-2206",
        SK_3: "SK-3"
    },

    PDFUtils = {
        adjustWordSpacing: function (widths, elements, callback) {
            var i, allLinesDone = false;
            var isDone = [];
            var currentSpacing = [];
            // Initialise arrays
            for (i = 0; i < widths.length; i++) {

                if (isIE) widths[i][1] = widths[i][1] * 4;
                if (elements[i].offsetWidth < widths[i][1]) {
                    currentSpacing[i] = Math.floor((widths[i][1] - elements[i].offsetWidth) / elements[i].innerHTML.match(/\s.|&nbsp;./g).length);//min
                    if (isIE) currentSpacing[i] = Math.floor(currentSpacing[i] / 4);
                    isDone[i] = false;
                } else {
                    currentSpacing[i] = 1;//too long
                    isDone[i] = true;
                }
            }

            while (!allLinesDone) {
                // Add each adjustment to the render queue without forcing a render
                for (i = 0; i < widths.length; i++) {
                    if (!isDone[i]) {
                        elements[i].style.wordSpacing = currentSpacing[i] + 'px';
                    }
                }

                allLinesDone = true;
                // If elements still need to be wider, add 1 to the word spacing
                for (i = 0; i < widths.length; i++) {
                    if (!isDone[i] && currentSpacing[i] < 160) {
                        if (elements[i].offsetWidth >= widths[i][1]) {
                            isDone[i] = true;
                        } else {
                            currentSpacing[i]++;
                            allLinesDone = false;
                        }
                    }
                }
            }

            for (i = 0; i < widths.length; i++) {
                elements[i].style.wordSpacing = (currentSpacing[i] - 1) + 'px';
            }
            if (null != callback) {
                callback();
            }
        }

    };

