var ProjectSettings = {
    shareUrl: ProjectGlobals.SHARE_URL,
    parentShareURL: ProjectGlobals.PARENT_SHARE_URL,
    isScenePreview: ProjectGlobals.IS_SCENE_PREVIEW,
    URLs: {
        chapterMenuJSONUrl: function () {
            if (AppUtils.nativeApp || AppUtils.offlineExport) {
                return 'projectMenuModel_' + ProjectSettings.shareUrl + ".json";
            } else if (ProjectGlobals.IS_TIP_OF_THE_DAY) {
                return 'http://selfpub.tapbookauthor.com/tipOfTheDayModel?action=getMenuModel&shareURL=' + ProjectSettings.shareUrl;
            } else {
                return '/newPlayer/menuModel.jsp?shareURL=' + ProjectSettings.shareUrl;
            }

        },
        chapterPagesJSONUrl: function () {
            if (AppUtils.nativeApp || AppUtils.offlineExport) {
                return 'projectModel_' + ProjectSettings.shareUrl + ".json";
            } else if (ProjectGlobals.IS_TIP_OF_THE_DAY) {
                return 'http://selfpub.tapbookauthor.com/tipOfTheDayModel?action=getProjectModel&shareURL=' + ProjectSettings.shareUrl;
            } else if (ProjectSettings.isScenePreview == false) {
                return '/newPlayer/projectModel.jsp?shareURL=' + ProjectSettings.shareUrl;
            } else if (ProjectSettings.isScenePreview == true) {
                return '/newPlayer/projectScenePreviewModel.jsp?shareURL=' + ProjectSettings.shareUrl;
            }
        },
        versionedProjectsUpdateUrl: function () {
            return ProjectGlobals.SERVER_ROOT + '/updater?action=checkActiveVersion';
        },
        projectArchiveDownloadURL: function () {
            return ProjectGlobals.SERVER_ROOT + '/projectArchiveFile?action=getSequenceZipContentForDownload&sequenceId=';
        },
        chapterStylesCssURL: function () {
            var validShareUrl = (null == ProjectSettings.parentShareURL) ? ProjectSettings.shareUrl : ProjectSettings.parentShareURL;
            if (AppUtils.nativeApp || AppUtils.offlineExport) {
                return 'custom_fonts/ckeditorContentCSS_' + validShareUrl + ".css";
            } else {
                return "/ckeditor/ckeditorContentCSS.jsp?shareURL=" + validShareUrl;
            }
        },
        IAPProjectURL: function () {
            return ProjectGlobals.SERVER_ROOT + '/newPlayer/projectPlayer.jsp?shareURL=';
        },
        shareUrlRequestURL: function () {
            return ProjectGlobals.SERVER_ROOT + '/json?'
        },
        chapterOrientationsURL: function () {
            return 'orientationSupport.json';
        }
    },
    HTTPRequestSettings: {
        contentTypeHeader: "application/x-www-form-urlencoded",
        acceptHeader: 'application/json',
        requestType: {
            POST: 'POST',
            GET: 'GET'
        }
    }
};