var YoutubeAPIState = {
    NOT_LOADED: 0,
    LOADING: 1,
    LOADED: 2
};

var YouTubeHelpers = {

    youtubeAPIState: YoutubeAPIState.NOT_LOADED,
    youtubeReadyHandlers: [],
    youtubeVideosArray: [],

    loadYoutubeAPIOnDemand: function () {
        YouTubeHelpers.youtubeAPIState = YoutubeAPIState.LOADING;
        var scriptTag = document.createElement('script');
        scriptTag.src = "http://www.youtube.com/iframe_api";
        var firstScriptTag = document.getElementsByTagName('script')[0];
        firstScriptTag.parentNode.insertBefore(scriptTag, firstScriptTag);
    },

    executeYoutubeReadyHandlers: function () {
        for (var idx = 0; idx < YouTubeHelpers.youtubeReadyHandlers.length; idx++) {
            YouTubeHelpers.youtubeReadyHandlers[idx]();
        }
        YouTubeHelpers.youtubeReadyHandlers = [];
    },

    startLoadingYoutubeVideo: function (youtubeVideoId, source, model) {
        if (YouTubeHelpers.youtubeAPIState == YoutubeAPIState.LOADED) {
            YouTubeHelpers.addYoutubeVideo(youtubeVideoId, source, model);
        } else {
            if (YouTubeHelpers.youtubeAPIState == YoutubeAPIState.NOT_LOADED) {
                YouTubeHelpers.loadYoutubeAPIOnDemand();
            }
            YouTubeHelpers.youtubeReadyHandlers.push(function () {
                YouTubeHelpers.addYoutubeVideo(youtubeVideoId, source, model);
            })
        }
    },

    addYoutubeVideo: function (youtubeVideoId, source, model) {
        var videoDidEnd;
        var youtubePlayerInstance = new YT.Player(youtubeVideoId, {
            height: '100%',
            width: '100%',
            videoId: source + "?version=3&wmode=opaque",//&playerapiid=" + youtubeVideoId
            playerVars: {
                rel: 0,
                enablejsapi: 1
            },
            events: {
                "onReady": function (e) {
                    if (model.get("autoPlay")) { // this is only for videos that will play in Lightbox
                        e.target.playVideo();
                    }
                    model.set('YTPlayer', e.target);
                },
                "onStateChange": function (state) {
                    console.log("YT video state is now " + state.data);
                    if (state.data == YT.PlayerState.ENDED) {
                        videoDidEnd = true;
                        youtubePlayerInstance.seekTo(0); // causes 1(playing) to be fired after
                    } else if (state.data == YT.PlayerState.PLAYING || state.data == YT.PlayerState.BUFFERING) {
                        if (videoDidEnd) {
                            // the timeout is needed when running on device,
                            // and also allows for the first frames of the video to load in order not to see a black video
                            setTimeout(function () {
                                videoDidEnd = false;
                                youtubePlayerInstance.pauseVideo();
                            }, 200);
                        }
                    }
                }
            }
        });
        //        YouTubeHelpers.youtubeVideosArray.push(youtubePlayerInstance);
    },

    removeAllYoutubeVideos: function () {
        for (var idx = 0; idx < YouTubeHelpers.youtubeVideosArray.length; idx++) {
            YouTubeHelpers.youtubeVideosArray[idx].destroy();
        }
    }
};

function onYouTubeIframeAPIReady() {
    YouTubeHelpers.youtubeAPIState = YoutubeAPIState.LOADED;
    YouTubeHelpers.executeYoutubeReadyHandlers();
}