define(function () {
    return function (rawAnchorModel, pageModel) {
        var that = this;

        this.defineClasses = function () {

            that.AnchorView = ElementBaseView.extend({
                tagName: "div",
                className: "sceneObject",
                elementsViews: [],
                id: rawAnchorModel.properties.id,
                parentElementModel: pageModel,
                events: function () {
                    var _events = {};
                    _events[AppUtils.EventTypes.mouseDown] = "touchstart";
                    _events[AppUtils.EventTypes.click] = "clickHandler";
                    _events["touchcancel"] = "touchcancelHandler";
                    _events["touchcend"] = "touchcendHandler";
                    return _events;
                },
                touchcendHandler: function () {
                    console.log("touchcendHandler on " + this.$el.attr("id"));
                },
                touchcancelHandler: function () {
                    console.log("touchcancelHandler on " + this.$el.attr("id"));
                },
                removeView: function () {
                    if (this.model.get("removed")) {
                        this.remove();
                        this.unbind();
                    }
                },
                activateObject: function () {
                    if (this.model.get("activateObject")) {
                        this.model.set("objectActivated", true);
                        this.model.set("activateObject", false);
                    }
                },
                activateToggle: function () {
                    this.displayHideOnceOnClick();
                },
                render: function () {
                    this.setLeft(this.model.get("left"));
                    this.setWidth(this.model.get("width"));
                    this.setHeight(this.model.get("height"));
                    this.setTop(this.model.get("top"));
                    this.setBackgroundColor(this.model.get('bgColor'), this.model.get('bgOpacity'));
                    this.setZIndex(this.model.get("ZIndex"));
                    //this.setInitialVisibility();
                    return this;
//                    return null;
                }
            });
        };
        this.instantiateObjects = function () {
            this.rawAnchorModel = this.getAnchorModel();
            this.anchorView = new this.AnchorView({
                model: that.rawAnchorModel
            });

        };

        this.getAnchorModel = function () {
            return  new Backbone.Model(rawAnchorModel.properties);
        };

        return {
            init: function () {
                that.defineClasses();
                that.instantiateObjects();
            },
            getView: function () {
                return that.anchorView;
            },
            getModel: function () {
                return that.rawAnchorModel;
            }

        }
    }
});