define(function () {
    return function (rawEmptyBoxModel, pageModel) {
        var that = this,
        mappedBorderStyleCSSClasses = {
            'Solid': 'divSolidBorder',
            'No border': 'divNoBorder',
            'Dotted': 'divDottedBorder',
            'Dashed': 'divDashedBorder',
            'Double': 'divDoubleBorder',
            'Groove': 'divGrooveBorder',
            'Ridge': 'divRidgeBorder'
        };

        this.defineClasses = function () {

            that.EmptyBoxView = ElementBaseView.extend({
                tagName: "div",
                className: "sceneObject",
                elementsViews: [],
                id: rawEmptyBoxModel.properties.id,
                parentElementModel: pageModel,

                customInitialize: function () {
                    this.model.set("allObjectTypesInPage", rawEmptyBoxModel.customProperties["allObjectTypesInPage"]);
                },
                events: function () {
                    var _events = {};
                    _events[AppUtils.EventTypes.mouseDown] = "touchstart";
//                    _events[AppUtils.EventTypes.mouseEnter] = "onMouseOverHandler";
//                    _events[AppUtils.EventTypes.mouseLeave] = "onMouseOutHandler";
                    _events[AppUtils.EventTypes.click] = "clickHandler";
                    _events["touchcancel"] = "touchcancelHandler";
                    _events["touchcend"] = "touchcendHandler";
                    return _events;
                },
                onMouseOverHandler: function () {
                },
                onMouseOutHandler: function () {
                },
                touchcendHandler: function () {
                    console.log("touchcendHandler on " + this.$el.attr("id"));
                },
                touchcancelHandler: function () {
                    console.log("touchcancelHandler on " + this.$el.attr("id"));
                },
                removeView: function () {
                    if (this.model.get("removed")) {
                        this.remove();
                        this.unbind();
                    }
                },
                activateObject: function () {
                    if (this.model.get("activateObject")) {
                        this.model.set("objectActivated", true);
                        this.model.set("activateObject", false);
                    }
                },
                activateToggle: function () {
                    this.displayHideOnceOnClick();
                },
                setBorder: function () {
                    this.$el.addClass(mappedBorderStyleCSSClasses[this.model.get('borderStyle')]);
                },

                render: function () {
                    if (this.shouldRenderObject()) {
                        this.renderStartHandler();
                        this.setLeft(this.model.get("left"));
                        this.setWidth(this.model.get("width"));
                        this.setHeight(this.model.get("height"));
                        this.setTop(this.model.get("top"));
                        this.setBackgroundColor(this.model.get('bgColor'), this.model.get('bgOpacity'));
                        this.setZIndex(this.model.get("ZIndex"));
                        this.setInitialVisibility();
                        this.startZoomEffectsIfNeeded();
                        this.setTitle(this.model.get("mouseoverTitle"));
                        this.setBorder();
                        return this;
                    }
                    return null;
                }
            });
        };
        this.instantiateObjects = function () {
            this.emptyBoxModel = this.getEmptyBoxModel();
            this.emptyBoxView = new this.EmptyBoxView({
                model: that.emptyBoxModel
            });

        };

        this.getEmptyBoxModel = function () {
            return  new Backbone.Model(rawEmptyBoxModel.properties);

        };


        return {
            init: function () {
                that.defineClasses();
                that.instantiateObjects();
            },
            getView: function () {
                return that.emptyBoxView;
            },
            getModel: function () {
                return that.emptyBoxModel;
            }

        }
    }
});