define(function () {
    return function (rawExternalURLModel, pageModel) {
        var that = this;

        this.defineClasses = function () {

            that.ExternalURLView = ElementBaseView.extend({
                tagName: "div",
                className: "sceneObject",
                elementsViews: [],
                template: templates.getTemplate("externalURL"),
                id: rawExternalURLModel.properties.id,
                parentElementModel: pageModel,
                events: function () {
                    var _events = {};
                    _events[AppUtils.EventTypes.mouseDown] = "touchstart";
                    _events[AppUtils.EventTypes.click] = "clickHandler";
                    _events["touchcancel"] = "touchcancelHandler";
                    _events["touchcend"] = "touchcendHandler";
                    return _events;
                },
                touchcendHandler: function () {
                    console.log("touchcendHandler on " + this.$el.attr("id"));
                },
                touchcancelHandler: function () {
                    console.log("touchcancelHandler on " + this.$el.attr("id"));
                },
                removeView: function () {
                    if (this.model.get("removed")) {
                        this.remove();
                        this.unbind();
                    }
                },
                activateObject: function () {
                    if (this.model.get("activateObject")) {
                        this.model.set("objectActivated", true);
                        this.model.set("activateObject", false);
                    }
                },
                activateToggle: function () {
                    this.displayHideOnceOnClick();
                },

                render: function () {
                    if (this.shouldRenderObject()) {
                        this.renderStartHandler();
                        if (null == this.$loadedTemplate)
                            this.$loadedTemplate = $(this.template(this.model.attributes));

                        this.$el.html(this.$loadedTemplate);
                        this.setLeft(this.model.get("left"));
                        this.setWidth(this.model.get("width"));
                        this.setHeight(this.model.get("height"));
                        this.setTop(this.model.get("top"));
                        this.$el.css("z-index", this.model.get("ZIndex"));
                        this.setInitialVisibility();
                        this.startZoomEffectsIfNeeded();
                        return this;
                    }
                    return null;
                }
            });
        };
        this.instantiateObjects = function () {
            this.externalURLModel = this.getExternalURLModel();
            this.externalURLView = new this.ExternalURLView({
                model: that.externalURLModel
            });

        };

        this.getExternalURLModel = function () {
            var model = new Backbone.Model(rawExternalURLModel.properties);
            model.set("externalURL", rawExternalURLModel.properties.externalURL);
            return model;
        };

        return {
            init: function () {
                that.defineClasses();
                that.instantiateObjects();
            },
            getView: function () {
                return that.externalURLView;
            },
            getModel: function () {
                return that.externalURLModel;
            }
        }
    }
});