(function ($) {

    var methods = {

        init: function (options) {

            var $this = this;
            var count = 0;

            if ($("#progressElement").length == 0) {
                var progressElement = $("<div id='progressElement'>").load("js/usersNotifications/spinner.html", function () {
                    console.log("Loading spinner was complete");
                    if ($("#progressElement").length == 0) {
                        if (options.showOnlySpinner) {
                            progressElement.find("#spinnerContainer").css({
                                "background": "rgba(255,255,255,0)"
                            });
                            progressElement.find("#spinnerMessage").hide();

                            //progressElement.find("#spinnerOverlay").hide();
                        }
                        if (options.darkVersion) {
                            for (i = 1; i < 9; i++) {
                                progressElement.find(".bar" + i).css({
                                    "background": "rgba(0,0,0," + (0.1 * i + 0.2) + ")"
                                })
                            }
                        }
                        if (options.backgroundOpacityCalendar) {
                            progressElement.find("#spinnerOverlay").css({
                                "background": "rgba(230,231,232,1)"
                            });
                            progressElement.find("#spinnerOverlay").show();
                        }
                        if (options.backgroundOpacityMyDay) {
                            progressElement.find("#spinnerOverlay").css({
                                "background": "rgba(255,255,255,1)"
                            });
                            progressElement.find("#spinnerOverlay").show();
                        }
                        if (options.backgroundOpacityGallery) {
                            progressElement.find("#spinnerOverlay").css({
                                "background": "rgba(64,64,65,1)"
                            });
                            progressElement.find("#spinnerOverlay").show();
                        }

                        $this.prepend(progressElement);
                        $("#spinnerMessage").text(CAPTIONS["WAIT_MESSAGE"]);
                        setTimeout(rotate, 100);
                    }
                });
            } else {
                console.log("Spinner already loaded");
            }

            function rotate() {
                var spinnerElement = document.getElementById('spinner');
                if (null != spinnerElement) {
                    spinnerElement.style.WebkitTransform = 'rotate(' + count + 'deg)';
                    if (count == 360) {
                        count = 0
                    }
                    count += 45;
                    var T1 = setTimeout(rotate, 100);
                    progressElement.data("T1", T1);
                }
            }

            return this;
        },

        onComplete: function (options) {
            var $progressElement = $("#progressElement");
            if ($progressElement.length > 0) {
                var T1 = $progressElement.data("T1");
                clearTimeout(T1);

                if (options.completionMessage != "") {
                    $("#spinnerOverlay").remove();
                    $("#spinnerContainer").remove();
                    $("#toastMessage").text(options.completionMessage).show();
                    setTimeout(function () {
                        $("#toastMessage").fadeOut(500, function () {
                            $progressElement.remove();
                        })
                    }, options.toastTimeout);
                } else {
                    $progressElement.remove();
                }
            } else {
                console.log("No spinner to dismiss");
            }
            return this;
        }
    };

    $.fn.SpinnerProgressIndicator = function (method) {

        // set up default options
        var defaults = {
            displayMessage: "",
            //displayMessage:CAPTIONS["WAIT_MESSAGE"], // TODO: check why it doesn't work
            completionMessage: "",
            toastTimeout: 2000,
            showOnlySpinner: false,
            darkVersion: false,
            backgroundOpacityCalendar: false,
            backgroundOpacityMyDay: false,
            backgroundOpacityGallery: false
        };

        // Method calling logic
        if (methods[method]) {
            var options = $.extend({}, defaults, arguments[1]);
            return methods[ method ].call(this, options);
        } else if (typeof method === 'object' || !method) {
            var options = $.extend({}, defaults, arguments[0]);
            return methods.init.call(this, options);
        } else {
            $.error('Method ' + method + ' does not exist on jQuery.SpinnerProgressIndicator');
        }
    };

})(jQuery);