/**
 * Created by ionutmovila on 11/12/14.
 */

function AppEventsEngine() {
    var eventsType = {
            APP_RESUME: 0,
            APP_PAUSE: 1
        },
        resumeSubscribers = [],
        privateMethods = {
            init: function () {
                console.log("init AppEventsEngine");
            },
            onAppPause: function () {
                console.log("onAppPause");
                Chapter.setAppPaused(true);
                Chapter.getScrollingElementsView().model.set("resetCurrentPage", false);
            },
            onAppResume: function () {
                console.log("onAppResume");
                Chapter.setAppPaused(false);
                Chapter.getScrollingElementsView().model.set("resetCurrentPage", true);
                privateMethods.notifyResumeSubscribers();
            },
            notifyResumeSubscribers: function () {
                var idx;
                for (idx = 0; idx < resumeSubscribers.length; idx++) {
                    // for now we just set a random value so the model will be changed each time
                    resumeSubscribers[idx]["model"].set(resumeSubscribers[idx]["attributeName"], new Date().getTime());
                }
            }
        },
        publicMethods = {
            initNativeAppEvents: function () {
                document.addEventListener("pause", privateMethods.onAppPause, false);
                document.addEventListener("resume", privateMethods.onAppResume, false);
            },
            getEventsType: function () {
                return eventsType;
            },
            subscribeToEvent: function (eventType, model, attributeName) {
                if (eventType == eventsType.APP_RESUME) {
                    resumeSubscribers.push({
                        "model": model,
                        "attributeName": attributeName
                    });
                } else if (eventType == eventsType.APP_PAUSE) {
                    console.log("AppEventsEngine subscribe was called for pause event that is not implemented");
                } else {
                    console.log("AppEventsEngine subscribe was called for an event that is not supported");
                }
            }
        };

    privateMethods.init();

    return publicMethods;
}

var appEventsEngine = new AppEventsEngine();

