OCUtils = {
    setCurrentCategoryAndUnsetTheRest: function (setCategoryId, activatedCategories, deactivatedCategories) {
        var categories = Chapter.getObjectCategories(),
            setCategory = categories[setCategoryId],
            complementaryCategories = this.getCategoryFromTheSameClass(setCategory),
            category, idx;
        if (complementaryCategories != null) {
            for (idx = 0; idx < complementaryCategories.length; idx++) {
                category = complementaryCategories [idx];
                if (categories.hasOwnProperty(category)) {
                    if (categories[category].active) {
                        categories[category].active = false;
                        deactivatedCategories[category] = true;
                    }
                }
            }
        }
        if (!setCategory.active) {
            setCategory.active = true;
            activatedCategories[setCategoryId] = true;
        }
    },
    getCategoryFromTheSameClass: function (setCategory) {
        var ret = setCategory.categoriesInClass.split(','), idx;
        for (idx = 0; idx < ret.length; idx++) {
            if (ret[idx] == '')
                ret.splice(idx, 1);
        }
        return ret.length == 0 ? null : ret;
    },
    extractActivatedCategoryFrom: function (OCIds, action, activatedCategories, deactivatedCategories) {
        var ocIdsIndex, categories = Chapter.getObjectCategories(),
            changedCategory;
        if (null != OCIds) {
            if (action == 'set') {
                for (ocIdsIndex = 0; ocIdsIndex < OCIds.length; ocIdsIndex++) {
                    if (categories.hasOwnProperty(OCIds[ocIdsIndex])) {
                        this.setCurrentCategoryAndUnsetTheRest(OCIds[ocIdsIndex], activatedCategories, deactivatedCategories);
                    }
                }
            } else if (action == 'add') {
                for (ocIdsIndex = 0; ocIdsIndex < OCIds.length; ocIdsIndex++) {
                    changedCategory = OCIds[ocIdsIndex];
                    if (typeof categories[changedCategory] != "undefined" && !categories[changedCategory].active) {
                        categories[changedCategory].active = true;
                        activatedCategories[changedCategory] = true;
                    }
                }
            } else if (action == 'remove') {
                for (ocIdsIndex = 0; ocIdsIndex < OCIds.length; ocIdsIndex++) {
                    changedCategory = OCIds[ocIdsIndex];
                    if (typeof categories[changedCategory] != "undefined" && categories[changedCategory].active) {
                        categories[changedCategory].active = false;
                        deactivatedCategories[changedCategory] = true;
                    }
                }
            } else if (action == 'toggle') {
                for (ocIdsIndex = 0; ocIdsIndex < OCIds.length; ocIdsIndex++) {
                    changedCategory = OCIds[ocIdsIndex];
                    if (typeof categories[changedCategory] != "undefined") {
                        if (!categories[changedCategory].active) {
                            categories[changedCategory].active = true;
                            activatedCategories[changedCategory] = true;
                        } else {
                            categories[changedCategory].active = false;
                            deactivatedCategories[changedCategory] = true;
                        }
                    }
                }
            } else if (action == 'move') {
                for (ocIdsIndex = 0; ocIdsIndex < OCIds.length; ocIdsIndex++) {
                    activatedCategories[OCIds[ocIdsIndex]] = true;
                }
            }
        }
    }
};