var PageUtils = {

    // only relevant when App.dualLandscapeActive
    // simple logic here: pages on the left have even numbers,
    // because for now first page (0) is always on the left side
    isPageOnTheLeftSide: function (pageNumber) {
        return App.dualLandscapeActive() && (pageNumber % 2 == 0);
    },

    runTimer: function (handler, delay) {
        var timerId, start, remaining = delay;

        this.pause = function () {
            window.clearTimeout(timerId);
            remaining -= new Date() - start;
        };

        this.resume = function () {
            start = new Date();
            window.clearTimeout(timerId);
            timerId = window.setTimeout(handler, remaining);
        };

        this.clearTimeout = function () {
            window.clearTimeout(timerId);
        };

        this.resume();
    },

    runInterval: function (handler, delay) {
        var intervalId, timerId, start, remaining = delay;

        var publicMethods = {
            pause: function () {
                window.clearInterval(intervalId);
                window.clearTimeout(timerId);
                remaining = new Date() - start;
                console.log(LOG_TAGS.MOB_2207, "Now pause interval. First iteration after resume will be after " + remaining);
            },

            resume: function () {
                start = new Date();
                window.clearInterval(intervalId);
                window.clearTimeout(timerId);
                timerId = window.setTimeout(function () {
                    console.log(LOG_TAGS.MOB_2207, "Running handler for timer " + timerId + " first time after resume with remaining " + remaining);
                    handler();
                    start = new Date();
                    intervalId = window.setInterval(function () {
                        console.log(LOG_TAGS.MOB_2207, "Running handler for interval " + intervalId + " with given interval " + delay + ". Previous run was " + (new Date() - start) + " ms ago");
                        start = new Date();
                        handler();
                    }, delay);
                }, remaining);
            },

            clearInterval: function () {
                console.log(LOG_TAGS.MOB_2207, "Now clear interval. TimerID " + timerId + ". IntervalID " + intervalId);
                window.clearInterval(intervalId);
                window.clearTimeout(timerId);
            }
        };

        console.log(LOG_TAGS.MOB_2207, "Now init interval repeating at " + delay);

        publicMethods.resume();

        return publicMethods;
    }
};