function FileDownloader() {
}

FileDownloader.prototype.downloadFile = function (fileName, url, optional, successCallback, failureCallback) {
    CordovaWrapper.execPlugin(successCallback, failureCallback, "FileDownloader", "downloadFile", [fileName, url, optional]);
};

FileDownloader.prototype.removeFileFromStorageFolder = function (fileName, successCallback, failureCallback) {
    CordovaWrapper.execPlugin(successCallback, failureCallback, "FileDownloader", "removeFileByName", [fileName]);
};

FileDownloader.prototype.updatePathForStartHTMLPage = function (htmlPath, successCallback, failureCallback) {
    CordovaWrapper.execPlugin(successCallback, failureCallback, "FileDownloader", "updatePathForStartHTMLPage", [htmlPath]);
};

// Only for iOS called to create a file before sound recording
FileDownloader.prototype.createFileInDocumentsFolder = function (fileName, successCallback, failureCallback) {
    CordovaWrapper.execPlugin(successCallback, failureCallback, "FileDownloader", "createFileInDocumentsFolder", [fileName]);
};

/*
 // Not working with new download system
 // Only in iOS for now
 FileDownloader.prototype.checkChapterIntegrity = function (chId, successCallback, failureCallback) {
 CordovaWrapper.execPlugin(successCallback, failureCallback, "FileDownloader", "checkChapterIntegrity", [chId]);
 };

 // Only in iOS for now
 FileDownloader.prototype.unzipPlayerAfterRecover = function (chId, successCallback, failureCallback) {
 CordovaWrapper.execPlugin(successCallback, failureCallback, "FileDownloader", "unzipPlayerAfterRecover", [chId]);
 };
 */

FileDownloader.install = function () {
    console.log("FileDownloader install");
    if (!window.plugins) {
        window.plugins = {};
    }
    window.plugins.FileDownloader = new FileDownloader();
    return window.plugins.FileDownloader;
};

CordovaWrapper.execConstructor(FileDownloader.install);