/**
 * Will be defined regardless if zoom enabled or not, in order to avoid type check in many places
 */
if (!window["ZoomUtils"]) window["ZoomUtils"] = {};
(function (ZoomUtils) {
    ZoomUtils.resetZoom = function () {
        console.log("ZoomUtils.resetZoom before change page");
        if (Chapter.getSettings()["zoomEnabled"]) {
            var zoomInstance = Chapter.getScrollingElementsView().getZoomElementForPage(Chapter.getActivePage()).getZoomInstance();
            zoomInstance.resetZoom();
            if (typeof ViewportPadding.zoomControls != "undefined") {
//                console.log("zoom value for slider is "+ViewportPadding.zoomControls.getZoomSliderModel().get("zoomValue"));
                ViewportPadding.zoomControls.getZoomSliderModel().set("zoomValue", 1);
            }
        }
    };

    ZoomUtils.updateZoomSlider = function (scale) {
        console.log("ZoomUtils.updateZoomSlider");
        if (typeof ViewportPadding.zoomControls != "undefined") {
            ViewportPadding.zoomControls.getZoomSliderModel().set("zoomValue", scale);
        }
    };

    ZoomUtils.updateZoomOnOrientationChange = function () {
        console.log("ZoomUtils.updateZoomOnOrientationChange");
        if (Chapter.getSettings()["zoomEnabled"]) {
            // here we do a complete remove of zoom instance and CSS created by iScroll for previous orientation
            var previousOrientation = App.lastKnownOrientation == SupportedOrientation.LANDSCAPE ? SupportedOrientation.PORTRAIT : SupportedOrientation.LANDSCAPE;
            // now decide if in previous orientation was dual page wrapper was used or regular page
            if (Chapter.getSettings()["useTwoInOneLandscapeMode"] && previousOrientation == SupportedOrientation.LANDSCAPE) {
                // iterate over all dual page elements
                Chapter.getScrollingElementsModel().set("updateZoomDualPage", true);
            } else {
                // iterate over all pages and remove zoom instances
                Chapter.getScrollingElementsModel().set("updateZoomDualPage", false);
            }
            Chapter.getActivePageElement().addZoomOnDemand();
            if (typeof ViewportPadding.zoomControls != "undefined") {
                console.log("zoom value for slider is " + ViewportPadding.zoomControls.getZoomSliderModel().get("zoomValue"));
                ViewportPadding.zoomControls.getZoomSliderModel().set("zoomValue", 1);
            }
        }
    };

    ZoomUtils.updateDummyDivForActivePageOnOrientationChange = function (pageNumber) {
        // check that is is last active page ?
        var leftValueForDummyDiv,
            dummyDualPageWrapper = $(".afterLastDualPageWrapper");
        if (pageNumber == App.maxActivePageNumberForDualLandscape()) {
            if (dummyDualPageWrapper.length == 0) {
                dummyDualPageWrapper = $("<div>").addClass("afterLastDualPageWrapper");
                $("#slidingScenes").append(dummyDualPageWrapper);
            }
            leftValueForDummyDiv = Math.abs(App.maxTranslateValueForLastPage()) + App.settings.width - 1;
            dummyDualPageWrapper.css("left", leftValueForDummyDiv + "px");
        } else if (dummyDualPageWrapper.length > 0) {
            dummyDualPageWrapper.remove();
        }
    };

})(window["ZoomUtils"]);